/***************************************************************************
*                        Computing Parity Checks
*
*   File    : algorithm_b.h
*   Purpose : Header file for library that solves correlation 
*             problem using algorithm B
*   Author  : Azhar Desai
*   Date    : September, 2011
*
****************************************************************************/
#ifndef ALGO_B_H
#define ALGO_B_H

/***************************************************************************
*                             INCLUDED FILES
***************************************************************************/
#include <stdio.h>
#include "bitarray.h"


/***************************************************************************
*                               PROTOTYPES
***************************************************************************/

/* Perform algorithm B on a given instance of correlation problem*/
void algorithm_b(double p, 
		 unsigned int l,  
		 unsigned int t, 
		 unsigned int taps [], 
		 unsigned int N, 
		 bit_array_t *z, 
		 bit_array_t *a);

/* Find threshold value for h, that maximises correct number of digit flips*/
unsigned int calc_h_max(double p,
			double s,
			unsigned int m);

/* Print current status of problem out to log file */
void printlogline(FILE *logfp, 
		  unsigned int i,
		  unsigned int N,
		  double p_thres,
		  double *p,
		  bit_array_t *z, 
		  bit_array_t *a);

#endif

