/***************************************************************************
*                        Computing Parity Checks
*
*   File    : main.h
*   Purpose : Function prototypes for main.h
*   Author  : Azhar Desai
*   Date    : September, 2011
*
****************************************************************************/
#ifndef MAIN_H
#define MAIN_H

/***************************************************************************
*                             INCLUDED FILES
***************************************************************************/
#include "algorithm_b.h"

/***************************************************************************
*                               PROTOTYPES
***************************************************************************/

/* read in input from file */
void m_readinputfile(const char filename [], 
		     double *p_p,
		     unsigned int *N_p,
		     unsigned int *l_p,
		     unsigned int *numtaps_p,
		     unsigned int **taps_p,
		     bit_array_t **z_p);

/* read in answer file */
void m_readansfile(const char filename [], bit_array_t **a_p, unsigned int N);

/* print bitarray to stdout */
void m_print_btarray(bit_array_t *z, unsigned int N);

/* print usage to stderr */
void m_printusage(const char progname []);

/* open file for reading, exit if failed */
FILE * m_open_exit_fail(const char filename [], const char errormsg []);

#endif
